﻿'From etoys2.2 of 1 October 2007 [latest update: #1675] on 10 January 2008 at 3:45:21 pm'!
"Change Set:		SWA-StackAttack
Date:			10 January 2008
Author:			Robert Krahn

Authors: Benjamin Emde, Matthias Jacob, Georg Koester, Fabian Lindenberg, Ole Rienow, Markus Steiner and, Christoph Thiele

Hasso-Plattner-Institut
Software Architecture Group
http://www.hpi.uni-potsdam.de/swa/"!

RectangleMorph subclass: #StackAttack
	instanceVariableNames: 'highscoreObject keyboardDictionary stackAttackField pictureDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttack commentStamp: 'fl 5/28/2007 21:57' prior: 0!
StackAttack contains details of the current game and reacts to the user's input.!

Object subclass: #StackAttackCreator
	instanceVariableNames: 'pictureDictionary stackAttackField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!
RectangleMorph subclass: #StackAttackField
	instanceVariableNames: 'fieldMatrix craneStack player1 player2 objectCreator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttackField commentStamp: 'fl 5/28/2007 22:26' prior: 0!
StackAttackField represents the field of the current game.!

TextMorph subclass: #StackAttackHighscore
	instanceVariableNames: 'highscore scoreDictionary highscoreText running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!
IconicButton subclass: #StackAttackInfo
	instanceVariableNames: 'stackAttack textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!
Matrix subclass: #StackAttackMatrix
	instanceVariableNames: 'randomObject randomMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!
ImageMorph subclass: #StackAttackMovableMorph
	instanceVariableNames: 'stackAttackField stateDictionary state currentDistance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttackMovableMorph commentStamp: 'fl 5/28/2007 22:25' prior: 0!
A MovableMorph has got the characteristics of a movable Object.!

StackAttackMovableMorph subclass: #StackAttackCrane
	instanceVariableNames: 'box randomValue randomObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttackCrane commentStamp: 'fl 5/28/2007 22:26' prior: 0!
A StackAttackCrane runs continously from the left to the right side, fetches new boxes and drops at a random position.!

StackAttackMovableMorph subclass: #StackAttackFallingMorph
	instanceVariableNames: 'matrixPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttackFallingMorph commentStamp: 'fl 5/28/2007 22:25' prior: 0!
A FallingMorph has got the characteristics of a falling Object.!

StackAttackFallingMorph subclass: #StackAttackBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttackBox commentStamp: 'fl 5/28/2007 22:05' prior: 0!
A StackAttackBox can be moved by a StackAttackPlayer and a StackAttackCrane.!

StackAttackFallingMorph subclass: #StackAttackPlayer
	instanceVariableNames: 'pictureDictionary isGameOver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttackPlayer commentStamp: 'fl 5/28/2007 22:25' prior: 0!
A StackAttackPlayer is able to move himself or a StackAttackBox in a StackAttackField.!

RectangleMorph subclass: #StackAttackSplash
	instanceVariableNames: 'stackAttack matrixSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-StackAttack'!

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:33'!
addAddCraneButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self pictureDictionary at: #addCraneButton);
		position: (self position + (0@50));
		actionSelector: 'initCrane';
		target: self stackAttackField.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:33'!
addCloseButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self pictureDictionary at: #closeButton);
		position: ((self upperRight) + (((self class buttonSize)negated)@0));
		actionSelector: 'delete';
		target: self.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:33'!
addDeleteCraneButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self pictureDictionary at: #deleteCraneButton);
		position: (self position + (0@100));
		actionSelector: 'deleteCrane';
		target: self stackAttackField.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:33'!
addInfoButton

	| button |
	button := StackAttackInfo new.
	button
		labelGraphic: (self pictureDictionary at: #infoButton);
		position: ((self upperRight) + (((self class buttonSize)negated)@(self class buttonSize)));
		stackAttack: self.
		
	self addMorph: button.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:34'!
addMultiplayerButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self pictureDictionary at: #multiplayerButton);
		position: (self position + (100@0));
		actionSelector: 'initSecondPlayer';
		target: self stackAttackField.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:34'!
addRestartButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self pictureDictionary at: #restartButton);
		position: self position;
		actionSelector: 'restartGame';
		target: self.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:34'!
addSingleplayerButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self pictureDictionary at: #singleplayerButton);
		position: (self position + (150@0));
		actionSelector: 'removeSecondPlayer';
		target: self stackAttackField.! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/17/2007 12:35'!
initButton

	| button |
	
	button := IconicButton new.
	button
		initializeAllButLabel;
		useRoundedCorners;
		borderStyle: (BorderStyle width: 0);
		color: Color transparent.

	self addMorph: button.
	^ button! !

!StackAttack methodsFor: 'buttons' stamp: 'or 7/8/2007 19:11'!
upperRight

	^ (self bounds corner x)@(self bounds origin y)! !

!StackAttack methodsFor: 'initialization' stamp: 'or 7/9/2007 23:12'!
addField: aTuple

	self
		stackAttackField: (StackAttackField new);
		addMorph: self stackAttackField.
	
	self stackAttackField 
		fieldBounds: aTuple;
		position: 
			(self bounds origin + (self class buttonSize @ (self class highscoreHeight))).! !

!StackAttack methodsFor: 'initialization' stamp: 'fl 7/8/2007 16:36'!
addHighscore

	self
		highscoreObject: StackAttackHighscore new;
		addMorph: self highscoreObject.
	self highscoreObject initPosition! !

!StackAttack methodsFor: 'initialization' stamp: 'be 7/9/2007 14:59'!
createFormFrom: aPath

	^ (ImageReadWriter formFromStream: ((FileStream fileNamed: aPath) binary))! !

!StackAttack methodsFor: 'initialization' stamp: 'fl 7/9/2007 22:45'!
initButtons

	self
		addRestartButton;
		addCloseButton;
		addAddCraneButton;
		addDeleteCraneButton;
		addInfoButton;
		addMultiplayerButton;
		addSingleplayerButton.! !

!StackAttack methodsFor: 'initialization' stamp: 'or 7/17/2007 12:35'!
initialize

	super initialize.
	self
		initializeKeyboardDictionary;
		initPictureDictionary;
		useRoundedCorners;
		setColor: (Color r: 0.278 g: 0.278 b: 0.278) borderWidth: 2 borderColor: Color black;
		addField: self class defaultSize;
		bounds: ((0@0) corner: self stackAttackSize);
		initSplash.
		! !

!StackAttack methodsFor: 'initialization' stamp: 'or 7/17/2007 12:00'!
initializeKeyboardDictionary

	self keyboardDictionary: 
		(IdentityDictionary new
			add: self class upKey 
				->	[self stackAttackField
						forwardKeyboard: StackAttackFallingMorph up.];
			add: self class macBookProUpKey 
				->	[self stackAttackField
						forwardKeyboard: StackAttackFallingMorph up.];
			add: self class leftKey
				->	[self stackAttackField
						forwardKeyboard: StackAttackMovableMorph left.];
			add: self class macBookProLeftKey
				->	[self stackAttackField
						forwardKeyboard: StackAttackMovableMorph left.];
			add: self class rightKey
				->	[self stackAttackField
						forwardKeyboard: StackAttackMovableMorph right.];
			add: self class macBookProRightKey
				->	[self stackAttackField
						forwardKeyboard: StackAttackMovableMorph right.];
			add: self class secondRightKey
				->	[self stackAttackField
						forwardSecondKeyboard: StackAttackMovableMorph right.];
			add: self class secondLeftKey
				->	[self stackAttackField
						forwardSecondKeyboard: StackAttackMovableMorph left.];
			add: self class secondUpKey
				->	[self stackAttackField
						forwardSecondKeyboard: StackAttackFallingMorph up.];		
			yourself).
	! !

!StackAttack methodsFor: 'initialization' stamp: 'OR 6/7/2007 16:57'!
initializeToStandAlone

	self initialize.! !

!StackAttack methodsFor: 'initialization' stamp: 'or 7/17/2007 12:27'!
initPictureDictionary

	self pictureDictionary: Dictionary new.
	self pictureDictionary
		at: #closeButton
			put: (self createFormFrom: self class closePicturePath);
		at: #addCraneButton
			put: (self createFormFrom: self class addCranePicturePath);
		at: #deleteCraneButton 
			put: (self createFormFrom: self class deleteCranePicturePath);
		at: #multiplayerButton
			put: (self createFormFrom: self class multiplayerPicturePath);
		at: #singleplayerButton
			put: (self createFormFrom: self class singleplayerPicturePath);
		at: #restartButton
			put: (self createFormFrom: self class restartPicturePath);
		at: #infoButton
			put: (self createFormFrom: self class infoPicturePath).! !

!StackAttack methodsFor: 'initialization' stamp: 'mja 7/22/2007 21:53'!
initSplash

	self addMorph: ((StackAttackSplash new)
							stackAttack: self;
							matrixSize: self class defaultSize;
							initButtons).
	.! !

!StackAttack methodsFor: 'initialization' stamp: 'CT 7/9/2007 15:02'!
stackAttackSize

	^ self stackAttackField fieldSize + (2 * (self class buttonSize @ self class buttonSize))! !

!StackAttack methodsFor: 'initialization' stamp: 'or 7/17/2007 12:35'!
startGame: aMatrixSize

	self	
		addHighscore;
		initButtons.
	self stackAttackField startGame: aMatrixSize.! !

!StackAttack methodsFor: 'currentGame' stamp: 'be 7/9/2007 19:02'!
gameOver
	
	self highscoreObject running: false! !

!StackAttack methodsFor: 'currentGame' stamp: 'or 7/16/2007 23:55'!
pause

	self stackAttackField submorphsDo: [:each | each stopStepping]! !

!StackAttack methodsFor: 'currentGame' stamp: 'mja 7/23/2007 03:07'!
restartGame

	self highscoreObject reset.

	self stackAttackField 
			removeAllMorphs;
			startGame: (self stackAttackField fieldMatrix rowCount)
							@(self stackAttackField fieldMatrix columnCount).! !

!StackAttack methodsFor: 'currentGame' stamp: 'or 7/16/2007 23:56'!
resume

	self stackAttackField submorphsDo: [:each | each startStepping]! !

!StackAttack methodsFor: 'eventHandling' stamp: 'fl 7/8/2007 16:34'!
handlesKeyboard: evt

	^ true! !

!StackAttack methodsFor: 'eventHandling' stamp: 'mja 6/1/2007 00:40'!
handlesMouseOver: evt

	^ true! !

!StackAttack methodsFor: 'eventHandling' stamp: 'mja 6/1/2007 00:39'!
hasFocus

	^ true! !

!StackAttack methodsFor: 'eventHandling' stamp: 'or 7/7/2007 15:52'!
keyStroke: anEvent 
	"When a key of the keyboardDictionary is pressed, perform the related action."
	
	(self keyboardDictionary at: anEvent keyValue ifAbsent: []) value.! !

!StackAttack methodsFor: 'eventHandling' stamp: 'mja 6/1/2007 02:57'!
mouseEnter: evt
	"Get KeyboardFocus when mouse hovers above me"
	
	ActiveHand newKeyboardFocus: self.! !

!StackAttack methodsFor: 'accessing' stamp: 'be 7/9/2007 14:40'!
highscoreObject
	"^ <highscoreObject>"

	^ highscoreObject! !

!StackAttack methodsFor: 'accessing' stamp: 'be 7/9/2007 14:41'!
highscoreObject: anObject

	highscoreObject := anObject! !

!StackAttack methodsFor: 'accessing' stamp: 'be 7/9/2007 14:39'!
keyboardDictionary
	"^ <IdentityDictionary>"
	
	^ keyboardDictionary! !

!StackAttack methodsFor: 'accessing' stamp: 'be 6/11/2007 20:32'!
keyboardDictionary: aDictionary

	keyboardDictionary := aDictionary! !

!StackAttack methodsFor: 'accessing' stamp: 'or 7/17/2007 12:11'!
pictureDictionary
	"Answer the value of pictureDictionary"

	^ pictureDictionary! !

!StackAttack methodsFor: 'accessing' stamp: 'or 7/17/2007 12:11'!
pictureDictionary: anObject
	"Set the value of pictureDictionary"

	pictureDictionary := anObject! !

!StackAttack methodsFor: 'accessing' stamp: 'be 7/9/2007 14:39'!
stackAttackField
	"^ <stackAttackField>"

	^ stackAttackField! !

!StackAttack methodsFor: 'accessing' stamp: 'be 7/9/2007 14:41'!
stackAttackField: anObject

	stackAttackField := anObject! !

!StackAttack methodsFor: 'highscore' stamp: 'be 7/18/2007 15:43'!
increaseHighscore: aSymbol

	self highscoreObject increase: aSymbol! !

!StackAttack methodsFor: 'highscore' stamp: 'be 7/9/2007 21:42'!
nextHighscoreLevel
	"stackAttackField adds a new crane when this score is reached"
	^ 250! !

!StackAttack methodsFor: 'resizing' stamp: 'be 7/9/2007 21:19'!
resize: aTuple

	self bounds: (self bounds origin
					corner: (self bounds corner
								+ (aTuple * StackAttackField pictureSize))).
	self stackAttackField bounds: (self stackAttackField bounds origin
					corner: (self stackAttackField bounds corner
								+ (aTuple * StackAttackField pictureSize)))! !


!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:10'!
addCranePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/plus.png'! !

!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:07'!
closePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/close.png'.! !

!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:10'!
deleteCranePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/minus.png'! !

!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:12'!
infoPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/instructions.png'! !

!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:11'!
multiplayerPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/multiplayer.png'! !

!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:12'!
restartPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/restart.png'! !

!StackAttack class methodsFor: 'buttonPicturePath' stamp: 'rkrk 1/10/2008 14:11'!
singleplayerPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/singleplayer.png'! !

!StackAttack class methodsFor: 'pictures' stamp: 'CT 7/9/2007 15:04'!
buttonSize
	^ 50! !

!StackAttack class methodsFor: 'pictures' stamp: 'be 7/9/2007 15:07'!
highscoreHeight

	^ 50! !

!StackAttack class methodsFor: 'initialization' stamp: 'mja 7/23/2007 00:53'!
defaultSize

	^ 11@8! !

!StackAttack class methodsFor: 'initialization' stamp: 'mr 7/10/2007 12:33'!
minSize

	^ 7@5! !

!StackAttack class methodsFor: 'accessing' stamp: 'OR 6/7/2007 16:53'!
descriptionForPartsBin

	^ self 
		partName: 'SWA-StackAttack'
		categories: #('Games')
		documentation: 'StackAttack Game'! !

!StackAttack class methodsFor: 'keyboard' stamp: 'CT 6/1/2007 15:34'!
leftKey
	
	^ 28 "cursor left"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'fl 6/26/2007 16:12'!
macBookProLeftKey
	
	^ 123 "cursor left"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'fl 6/26/2007 16:12'!
macBookProRightKey
	
	^ 124 "cursor right"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'fl 6/26/2007 16:12'!
macBookProUpKey
	
	^ 126 "cursor up"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'CT 6/1/2007 15:34'!
rightKey
	
	^ 29 "cursor right"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'or 7/7/2007 15:51'!
secondLeftKey
	
	^ 97 "a"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'or 7/7/2007 15:51'!
secondRightKey
	
	^ 100 "d"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'or 7/7/2007 15:52'!
secondUpKey
	
	^ 119 "w"! !

!StackAttack class methodsFor: 'keyboard' stamp: 'CT 6/1/2007 15:34'!
upKey
	
	^ 30 "cursor up"! !


!StackAttackCreator methodsFor: 'initialization' stamp: 'be 7/9/2007 14:08'!
createFormFrom: aPath

	^ (ImageReadWriter formFromStream: ((FileStream fileNamed: aPath) binary))! !

!StackAttackCreator methodsFor: 'initialization' stamp: 'or 7/6/2007 20:09'!
initialize

	self 
		initPictureDictionary.! !

!StackAttackCreator methodsFor: 'initialization' stamp: 'or 7/17/2007 12:11'!
initPictureDictionary

	self pictureDictionary: Dictionary new.
	self pictureDictionary
		at: #player
			put: (self createFormFrom: self class playerPicturePath);
		at: #playerGameOver
			put: (self createFormFrom: self class playerUpPicturePath);
		at: #secondPlayer 
			put: (self createFormFrom: self class secondPlayerPicturePath);
		at: #secondPlayerGameOver 
			put: (self createFormFrom: self class secondPlayerUpPicturePath);
		at: #box
			put: (self createFormFrom: self class boxPicturePath);
		at: #crane
			put: (self createFormFrom: self class cranePicturePath).! !

!StackAttackCreator methodsFor: 'creating' stamp: 'CT 7/9/2007 16:22'!
makeBoxAt: aPosition

	| box |
	box := StackAttackBox new.
	box
		stackAttackField: self stackAttackField; 
		image: (self pictureDictionary at: #box);
		matrixPos: aPosition.
	self stackAttackField fieldMatrix putInto: box.
	self stackAttackField addMorph: box.
	^ box! !

!StackAttackCreator methodsFor: 'creating' stamp: 'CT 7/9/2007 16:23'!
makeCrane

	| crane |
	crane := StackAttackCrane new.
	crane
		stackAttackField: self stackAttackField; 
		position: ((self stackAttackField bounds origin) - ((StackAttackField pictureSize)@0));
		image: (self pictureDictionary at: #crane).
	self stackAttackField addMorph: crane.

	^ crane! !

!StackAttackCreator methodsFor: 'creating' stamp: 'mja 7/23/2007 02:16'!
makePlayerAt: aPosition as: aSymbol

	| player |
	player := StackAttackPlayer new.
	player
		isGameOver: false;
		stackAttackField: self stackAttackField; 
		image: (self pictureDictionary at: aSymbol);
		matrixPos: aPosition.

	self stackAttackField fieldMatrix putInto: player.
	self stackAttackField addMorph: player.
	^ player.! !

!StackAttackCreator methodsFor: 'accessing' stamp: 'be 7/9/2007 21:22'!
pictureDictionary
	"^ <Dictionary>"
	
	^ pictureDictionary! !

!StackAttackCreator methodsFor: 'accessing' stamp: 'be 7/9/2007 21:21'!
pictureDictionary: aDictionary

	pictureDictionary := aDictionary! !

!StackAttackCreator methodsFor: 'accessing' stamp: 'be 7/9/2007 21:22'!
stackAttackField
	"^ <StackAttackField>"
	
	^ stackAttackField! !

!StackAttackCreator methodsFor: 'accessing' stamp: 'be 7/9/2007 21:22'!
stackAttackField: aStackAttackField

	stackAttackField := aStackAttackField! !


!StackAttackCreator class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:13'!
boxPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/kiste.jpg'! !

!StackAttackCreator class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:13'!
cranePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/crane.png'! !

!StackAttackCreator class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:12'!
playerPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/player.png'! !

!StackAttackCreator class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:12'!
playerUpPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/playerup.png'! !

!StackAttackCreator class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:13'!
secondPlayerPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/secondplayer.png'! !

!StackAttackCreator class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:13'!
secondPlayerUpPicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/secondplayerup.png'! !


!StackAttackField methodsFor: 'lastLineInspection' stamp: 'mja 7/23/2007 03:01'!
checkLastLine
	"checks if last line should be deleted"

	(self isPlayerInLastLine)
		ifFalse: [ 
			( 1 to: (self fieldMatrix gameColumnCount)) 
  				do: [ :x | (self fieldMatrix
							isFilledAt: (x@(self fieldMatrix gameRowCount)) )
				ifFalse: [ ^ nil ] ].
			self removeLastLine. ]
	
! !

!StackAttackField methodsFor: 'lastLineInspection' stamp: 'or 7/8/2007 01:17'!
checkPicture

	self 
		checkPictureUp;
		checkPictureDown.! !

!StackAttackField methodsFor: 'lastLineInspection' stamp: 'be 7/9/2007 21:45'!
checkPictureDown

	(self player1 matrixPos = (self player2 matrixPos + StackAttackFallingMorph down))
		ifTrue: [ 
			self player1 
				changePicture: #playerGameOver;
				isGameOver: true ].
	
	(self player2 matrixPos = (self player1 matrixPos + StackAttackFallingMorph down))
		ifTrue: [ 
			self player2 
				changePicture: #secondPlayerGameOver;
				isGameOver:true ].! !

!StackAttackField methodsFor: 'lastLineInspection' stamp: 'be 7/9/2007 21:52'!
checkPictureUp

	((self player1 checkCollision: StackAttackFallingMorph up) = #object)
		ifFalse: [ 
			self player1 
				changePicture: #player;
				isGameOver: false. ].
	
	(self player2 matrixPos = (0@0)) "tests if player2 is a dummy"
		ifFalse:[
			((self player2 checkCollision: StackAttackFallingMorph up) = #object)
			ifFalse: [ 
				self player2 
					changePicture: #secondPlayer;
					isGameOver: false ] ].! !

!StackAttackField methodsFor: 'lastLineInspection' stamp: 'mja 7/23/2007 03:02'!
deleteLastLine

	(1 to: (self fieldMatrix gameColumnCount))
		do: [ :x |
				(self fieldMatrix getObjectAt: x@(self fieldMatrix gameRowCount)) delete.
				self fieldMatrix resetAt: x@(self fieldMatrix gameRowCount) ]! !

!StackAttackField methodsFor: 'lastLineInspection' stamp: 'mja 7/23/2007 03:02'!
isPlayerInLastLine

	^ (self player1 matrixPos y) = (self fieldMatrix gameRowCount)
		or: [(self player2 matrixPos y) = (self fieldMatrix gameRowCount)]! !

!StackAttackField methodsFor: 'lastLineInspection' stamp: 'mja 7/23/2007 00:48'!
removeLastLine
	"removes the objects in last line of matrix"

	self 
		deleteLastLine;
		increaseHighscore: #line! !

!StackAttackField methodsFor: 'craneControl' stamp: 'or 7/17/2007 12:44'!
checkNewCrane

	( self owner highscoreObject highscore
		> (self craneStack size * self owner nextHighscoreLevel) )
			ifTrue: [ self initCrane ]! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 21:32'!
craneStack
	"^ <Stack>"
	
	^ craneStack! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/7/2007 18:09'!
craneStack: aStack

	craneStack := aStack! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:11'!
fieldMatrix
	"^ <Matrix>"
	
	^ fieldMatrix! !

!StackAttackField methodsFor: 'accessing' stamp: 'mja 6/12/2007 21:34'!
fieldMatrix: aMatrix

	fieldMatrix := aMatrix! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:12'!
objectCreator
	"^ <StackAttackCreator>"

	^ objectCreator! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:12'!
objectCreator: anObject

	objectCreator := anObject! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:13'!
player1
	"^ <StackAttackPlayer>"
	
	^ player1! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:13'!
player1: aStackAttackPlayer

	player1 := aStackAttackPlayer! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:13'!
player2
	"^ <StackAttackPlayer>"

	^ player2! !

!StackAttackField methodsFor: 'accessing' stamp: 'be 7/9/2007 22:13'!
player2: aStackAttackPlayer

	player2 := aStackAttackPlayer! !

!StackAttackField methodsFor: 'removing' stamp: 'mja 7/17/2007 12:24'!
deleteCrane

	| DeletedCrane |
	(self craneStack isEmpty)
		ifFalse: [ 
			DeletedCrane := self craneStack pop.
			(DeletedCrane box)
				ifNotNil: [ 
					self fieldMatrix resetAt: DeletedCrane box matrixPos.
					DeletedCrane box delete. ].
			DeletedCrane delete. ]! !

!StackAttackField methodsFor: 'removing' stamp: 'be 7/9/2007 22:03'!
removeSecondPlayer

	(self player2 matrixPos = (0@0))
		ifFalse: [
			self player2 delete.
			self fieldMatrix resetAt: self player2 matrixPos.
			self initPlayerDummy. ]! !

!StackAttackField methodsFor: 'initialization' stamp: 'or 7/9/2007 23:12'!
fieldBounds: aTuple

	self bounds: ( 0@0 corner: ( (0 @ self class craneHeight)
								+ (aTuple * self class pictureSize) ) )
! !

!StackAttackField methodsFor: 'initialization' stamp: 'be 7/9/2007 21:56'!
fieldSize

	^ (0 @ self class craneHeight)
		+ (StackAttack defaultSize * self class pictureSize)

	! !

!StackAttackField methodsFor: 'initialization' stamp: 'CT 7/9/2007 16:27'!
initBoxAt: aPosition

	| box |
	box := self objectCreator makeBoxAt: aPosition.
	box position: (self bounds origin) 
					+ (0@(self class craneHeight)) 
					+ ((self class pictureSize)
							* (aPosition - (1@1)) ).! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 04:09'!
initCrane

	(self craneStack size < self fieldMatrix gameColumnCount)
		ifTrue: [ self craneStack push: self objectCreator makeCrane ]! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 14:16'!
initialize
	"initialization of the game."
	
	super initialize.
	
	self objectCreator: StackAttackCreator new.
	self objectCreator stackAttackField: self.
	self
		setProperty: #clipSubmorphs toValue: true;
		setColor: (Color r: 0.529 g: 0.529 b: 0.529) borderWidth: 0 borderColor: Color transparent! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 01:11'!
initMatrix: aMatrixSize

	| aSample |

	self fieldMatrix: ( StackAttackMatrix
						rows: (aMatrixSize x)
						columns: (aMatrixSize y) ).
	
	self fieldMatrix initRandomMatrix.
	aSample := self fieldMatrix randomMatrix.
		
	aSample withIndicesDo: [:each :x :y | 
			(each = #box)
				ifTrue: [ self initBoxAt: (x@y) ].
			(each = #player1)
				ifTrue: [ self initPlayerAt: (x@y) ]. ]! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 02:21'!
initPlayerAt: aPosition

	self player1:
		((self objectCreator makePlayerAt: aPosition as: #player)
			position: (self bounds origin) 
							+ (0@(StackAttackField craneHeight)) 
							+ ((StackAttackField pictureSize)
								* (aPosition - (1@1)) )).
! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 02:42'!
initPlayerDummy

	self player2: ((StackAttackPlayer new)
						matrixPos: 0@0;
						isGameOver: true).
! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 02:46'!
initSecondPlayer

	(self fieldMatrix isFilledAt: self secondPlayerDropPosition)
		ifFalse: [
			(self player2 matrixPos = (0@0))
				ifTrue: [
					self player2: (((self objectCreator
										makePlayerAt: self secondPlayerDropPosition
										as: #secondPlayer)
										position: (self bounds origin) 
											+ (0@(self class craneHeight)) 
											+ ((self class pictureSize)
												* (self secondPlayerDropPosition - (1@1)) ))
										state: #fall). ] ]! !

!StackAttackField methodsFor: 'initialization' stamp: 'mja 7/23/2007 02:43'!
secondPlayerDropPosition

	^ 1@2! !

!StackAttackField methodsFor: 'initialization' stamp: 'CT 7/9/2007 17:04'!
startGame: aMatrixSize

	self
		initMatrix: aMatrixSize;
		craneStack: Stack new;
		initCrane;
		initPlayerDummy.! !

!StackAttackField methodsFor: 'keyboard' stamp: 'be 7/21/2007 23:19'!
forwardKeyboard: aDirection

	(self player1 isGameOver)
		ifFalse: [
			(aDirection = StackAttackFallingMorph up)
				ifTrue: 	[ self player1 jump ]
				ifFalse:	[ self player1 move: aDirection ]]! !

!StackAttackField methodsFor: 'keyboard' stamp: 'be 7/21/2007 23:18'!
forwardSecondKeyboard: aDirection

	(self player2 isGameOver)
		ifFalse: [
			(aDirection = StackAttackFallingMorph up)
				ifTrue: 	[ self player2 jump ]
				ifFalse:	[ self player2 move: aDirection ] ]! !

!StackAttackField methodsFor: 'highscore' stamp: 'CT 6/15/2007 17:28'!
increaseHighscore: aTyp

	self owner increaseHighscore: aTyp	! !


!StackAttackField class methodsFor: 'pictures' stamp: 'CT 7/9/2007 14:41'!
craneHeight
	^ 100! !

!StackAttackField class methodsFor: 'pictures' stamp: 'CT 7/9/2007 14:44'!
pictureSize
	^ 50! !


!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:24'!
highscore
	"^ <Integer>"
	
	^ highscore! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:25'!
highscoreText
	"^ <TextMorph>"
	
	^ highscoreText! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:25'!
highscoreText: aTextMorph

	highscoreText := aTextMorph! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:24'!
highscore: aValue

	highscore := aValue! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:26'!
running
	"^ <Boolean>"
	
	^ running! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:25'!
running: aBoolean

	running := aBoolean! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:27'!
scoreDictionary
	"^ <Dictionary>"
	
	^ scoreDictionary! !

!StackAttackHighscore methodsFor: 'accessing' stamp: 'be 7/9/2007 23:27'!
scoreDictionary: aDictionary

	scoreDictionary := aDictionary! !

!StackAttackHighscore methodsFor: 'highscoreOperations' stamp: 'be 7/18/2007 15:46'!
increase: aSymbol

	(self running)
		ifTrue: [
			self
				highscore: (self highscore + (self scoreDictionary at: aSymbol));
				update.
			self owner stackAttackField checkNewCrane. ]
	
	! !

!StackAttackHighscore methodsFor: 'highscoreOperations' stamp: 'be 7/18/2007 15:46'!
reset

	self 
		highscore: 0;
		update;
		running: true.! !

!StackAttackHighscore methodsFor: 'highscoreOperations' stamp: 'be 7/18/2007 15:46'!
update

	| text1 font highscoreAsText |
		highscoreAsText := self highscore printStringLength: 4 padded: true.
		font := TextFontReference toFont: (StrikeFont familyName: 'Atlanta' size: 22).
		text1 := highscoreAsText asText addAttribute: font.
		self contents: text1! !

!StackAttackHighscore methodsFor: 'positioning' stamp: 'CT 6/19/2007 20:14'!
initPosition

	self position: (self ownerUpperRight -((self ownWidth + 100)@-7)).! !

!StackAttackHighscore methodsFor: 'positioning' stamp: 'CT 6/19/2007 20:12'!
ownerUpperRight

	^ (self owner bounds corner x)@(self owner bounds origin y)! !

!StackAttackHighscore methodsFor: 'positioning' stamp: 'CT 6/19/2007 12:19'!
ownWidth

	^ ((self bounds corner x) - (self bounds origin x))! !

!StackAttackHighscore methodsFor: 'initialization' stamp: 'mja 7/21/2007 01:05'!
initialize

	super initialize.
	self
		highscore: 0;
		margins: 3@3;
		borderWidth: 2;
		running: true;
		useRoundedCorners;
		initializeScoreDictionary;
		setColor;
		lock;
		update.! !

!StackAttackHighscore methodsFor: 'initialization' stamp: 'CT 6/19/2007 11:49'!
initializeScoreDictionary

	| line box |
		line := 100.
		box := 5.
		
		self scoreDictionary: Dictionary new.
		self scoreDictionary
				at: #line put: line;
				at: #box put: box.! !

!StackAttackHighscore methodsFor: 'initialization' stamp: 'CT 6/19/2007 20:19'!
setColor

	self 
		borderColor: (Color r: 0.972 g: 0.69 b: 0.16);
		textColor: (Color r: 0.972 g: 0.69 b: 0.16)! !


!StackAttackInfo methodsFor: 'event handling' stamp: 'or 7/17/2007 11:43'!
deleteText

	self textMorph delete.
	self stackAttack resume.! !

!StackAttackInfo methodsFor: 'event handling' stamp: 'or 7/17/2007 11:43'!
displayedText

	^ 
'Goal of the Game
=========

StackAttack takes place in a warehouse filled with several stacks of  
boxes. The aim of the game is to fill the lowest row by moving single  
boxes. Achieving this causes the disappearance of this row. The  
player as well as the remaining boxes fall to the next lower level.
In addition the crane drops new boxes which have to be placed  
accordingly, too. If the Player gets hit by a falling box the game is over.
Furthermore the player receives 100 points per filled line and 5  
points for each falling box so that the score increases continuously.
At some scorelevels the difficulty is increased by adding a new crane.
Therefore the player’s objective should be to achieve a high score  
while he is trying to avoid the falling boxes.


Control
=========

The Player is moved by using the arrow keys. If you are playing in  
multiplayer mode you can move the second player using W,A and D.


Buttons in main menu
===============

Size of the field:

Before the game starts you can change the size of the field  
horizontally and vertically using the arrows in the main menu. Thus the player 
is able to change the level of difficulty at his will.

Play Button:

The game starts by clicking the Play-Button in the upper left corner  
of the main menu.

Buttons in game
===============

Crane buttons:

Using the plus and minus buttons at the left border of the field it  
is possible to manually add or remove cranes to change the level of  
difficulty at any time.

Two-player button:

During the game a second player can be added by clicking the two- 
player button. As both players are trying to achieve the same aim,  
they are on a team helping one another. For example the players are  
capable of saving each other’s lifes. If one player is covered by a  
box the second player can brush the box aside.
Another new possible action is to help each other up. One player can  
jump on the other to reach higher stacks.
With a click on the one-player button the second player gets removed  
and the fun can go on alone.
'

	
! !

!StackAttackInfo methodsFor: 'event handling' stamp: 'or 7/16/2007 23:48'!
handlesMouseOver: evt

	^ true! !

!StackAttackInfo methodsFor: 'event handling' stamp: 'or 7/16/2007 23:49'!
mouseEnter: evt
	"Get KeyboardFocus when mouse hovers above me"
	
	self showText.! !

!StackAttackInfo methodsFor: 'event handling' stamp: 'or 7/16/2007 23:49'!
mouseLeave: evt
	"Get KeyboardFocus when mouse hovers above me"
	
	self deleteText.! !

!StackAttackInfo methodsFor: 'event handling' stamp: 'or 7/17/2007 11:44'!
showText

	self initTextMorph.
	self stackAttack pause.! !

!StackAttackInfo methodsFor: 'initialization' stamp: 'mja 7/21/2007 01:07'!
initialize

	super initialize.
	self
		initializeAllButLabel;
		useRoundedCorners;
		borderStyle: (BorderStyle width: 0);
		color: Color transparent.! !

!StackAttackInfo methodsFor: 'initialization' stamp: 'mja 7/21/2007 01:50'!
initTextMorph

	self textMorph: PluggableTextMorph new.
	
	self textMorph
		setText: self displayedText;
		bounds: self stackAttack stackAttackField bounds;
		color: Color gray.
	self addMorph: self textMorph.! !

!StackAttackInfo methodsFor: 'accessing' stamp: 'be 7/21/2007 23:20'!
stackAttack
	"^ <StackAttack>"
	
	^ stackAttack! !

!StackAttackInfo methodsFor: 'accessing' stamp: 'be 7/21/2007 23:21'!
stackAttack: aStackAttack
	
	stackAttack := aStackAttack! !

!StackAttackInfo methodsFor: 'accessing' stamp: 'be 7/21/2007 23:22'!
textMorph
	"^ <PluggableTextMorph>"
	
	^ textMorph! !

!StackAttackInfo methodsFor: 'accessing' stamp: 'be 7/21/2007 23:22'!
textMorph: aPluggableTextMorph

	textMorph := aPluggableTextMorph! !


!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 00:47'!
freeColumns
	"returns a collection of column indices where boxes can be dropped by the cranes"
	
	| column rowIndices |
	rowIndices := OrderedCollection new.
	
	column := self atColumn: self class lowestFillableColumnIndex.
	1 to: column size do: [ :rowNumber |
		(column atWrap: rowNumber)
			ifNil: [ 
				(self isFilledAt: rowNumber@1)
					ifFalse: [ rowIndices add: rowNumber ]
			]
	].
	
	^ rowIndices! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 02:58'!
gameColumnCount
	"returns the ingame number of columns, because of the transposition it is rowCount"

	^ self rowCount! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 02:58'!
gameRowCount
	"returns the ingame number of rows, because of the transposition it is columnCount"

	^ self columnCount! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 00:39'!
getObjectAt: aPosition

	^ self at: (aPosition x) at: (aPosition y)! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 00:31'!
isFilledAt: aPosition

	^ ((self at: aPosition x at: aPosition y) = nil) not! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 00:39'!
moveObjectFrom: aPosition to: anotherPosition

	self
		at: anotherPosition x at: anotherPosition y 
			put: (self at: aPosition x at: aPosition y);
		at: aPosition x at: aPosition y 
			put: nil.! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 00:31'!
putInto: aStackAttackBox

	| boxPos |
	boxPos := aStackAttackBox matrixPos.
	self at: boxPos x at: boxPos y put: aStackAttackBox.! !

!StackAttackMatrix methodsFor: 'matrixOperations' stamp: 'mja 7/23/2007 00:40'!
resetAt: aPosition

	self at: aPosition x at: aPosition y put: nil! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 7/23/2007 00:55'!
highestFillableColumnIndex: anArray
	"returns the index before the first element that is not nil"
	
	| pointer |
	
	pointer := self class lowestFillableColumnIndex.
	
	[((anArray atWrap: pointer + 1) = nil)
	and: [pointer + 1 <= anArray size]]
		whileTrue: [pointer := pointer + 1].	
		
	^ pointer! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 7/14/2007 17:59'!
initialize

	super initialize.
	self	randomObject: Random new! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 6/26/2007 17:56'!
initRandomMatrix

	| heights |
	
	heights := self initStackHeights.
	self randomMatrix: (self initRandomMatrixWith: heights).! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 7/23/2007 03:29'!
initRandomMatrixWith: anArray
	"returns a matrix containing as much boxes in each column as given in anArray"
	
	| tempMatrix |
	
	tempMatrix := Matrix rows: self rowCount columns: self columnCount.
	tempMatrix withIndicesDo: [ :each :row :col |
		(col >= (self columnCount - (anArray atWrap: row) + 1))
			ifTrue: [ tempMatrix at: row at: col put: #box ]. ].
	self setPlayerIntoMatrix: tempMatrix.
			
	 ^ tempMatrix.! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 7/23/2007 01:45'!
initStackHeights
	"randomly generates an array representing the number of boxes in each row"
	
	| row heights boxLimit |
	heights := Array new: self columnCount withAll: 0.
	boxLimit := self columnCount.
	
	1 to: boxLimit do: [ :each |
		row := self randomRow.
		[(heights atWrap: row) >= self columnCount]
			whileTrue: [row := self randomRow].
		heights atWrap: row put: (heights atWrap: row) + 1. ].

	^ heights! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 7/23/2007 00:33'!
randomRow

	^ self randomObject nextInt: self rowCount.! !

!StackAttackMatrix methodsFor: 'initialization' stamp: 'mja 7/23/2007 00:59'!
setPlayerIntoMatrix: aMatrix

	| row columnIndex |
	row := self randomRow.
	columnIndex := self highestFillableColumnIndex: (aMatrix atRow: row).
	
	[columnIndex = self class lowestFillableColumnIndex]
		whileTrue: [ row := self randomRow.
					 columnIndex := self highestFillableColumnIndex: (aMatrix atRow: row). ].
				
	aMatrix at: row at: columnIndex put: #player1.! !

!StackAttackMatrix methodsFor: 'accessing' stamp: 'be 7/9/2007 23:42'!
randomMatrix
	"^ <Matrix>"
	
	^ randomMatrix! !

!StackAttackMatrix methodsFor: 'accessing' stamp: 'be 7/9/2007 23:42'!
randomMatrix: aMatrix

	randomMatrix := aMatrix! !

!StackAttackMatrix methodsFor: 'accessing' stamp: 'be 7/9/2007 23:41'!
randomObject
	"^ <Random>"
	
	^ randomObject! !

!StackAttackMatrix methodsFor: 'accessing' stamp: 'be 7/9/2007 23:40'!
randomObject: aRandom

	randomObject := aRandom! !


!StackAttackMatrix class methodsFor: 'accessing' stamp: 'mja 7/23/2007 00:44'!
lowestFillableColumnIndex

	^ 2! !

!StackAttackMatrix class methodsFor: 'accessing' stamp: 'mja 7/23/2007 03:11'!
lowestFillableGameRowIndex

	^ self lowestFillableColumnIndex! !


!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:41'!
currentDistance
	"^ <Integer>"

	^ currentDistance! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:43'!
currentDistance: anInteger

	currentDistance := anInteger! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:41'!
stackAttackField
	"^ <StackAttackField>"

	^ stackAttackField! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:42'!
stackAttackField: aStackAttackField

	stackAttackField := aStackAttackField! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:42'!
state
	"^ <Symbol>"
	
	^ state! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:42'!
stateDictionary
	"^ <IdentityDictionary>"
	
	^ stateDictionary! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 6/13/2007 20:30'!
stateDictionary: anIdentityDictionary

	stateDictionary := anIdentityDictionary! !

!StackAttackMovableMorph methodsFor: 'accessing' stamp: 'be 6/13/2007 20:29'!
state: aSymbol

	state := aSymbol! !

!StackAttackMovableMorph methodsFor: 'distance' stamp: 'be 7/5/2007 21:41'!
increaseCurrentDistance

	self currentDistance: 
		self currentDistance + self standardMove! !

!StackAttackMovableMorph methodsFor: 'distance' stamp: 'CT 6/14/2007 01:32'!
standardMove
	
	^ 5! !

!StackAttackMovableMorph methodsFor: 'graphicMovement' stamp: 'be 7/5/2007 22:17'!
moveGraphic: aDirection
	
	self position: 
		self position + (self standardMove * aDirection)
! !

!StackAttackMovableMorph methodsFor: 'stepping' stamp: 'fl 7/18/2007 19:14'!
stepHorizontal: aDirection

	self subclassResponsibility! !


!StackAttackCrane methodsFor: 'craneMovement' stamp: 'be 7/9/2007 19:18'!
beamLeft

	self position: self startPosition.
	(self box)
		ifNotNil: [
			self box position:
				self startPosition + (0@(StackAttackField craneHeight)) ]! !

!StackAttackCrane methodsFor: 'craneMovement' stamp: 'be 7/21/2007 23:16'!
createARandomValue
	"picks a column where the box can be dropped"

	| dropColumns |
	dropColumns := self stackAttackField fieldMatrix freeColumns.
	
	(dropColumns size = 0)
		ifFalse: [
			self randomValue: (dropColumns
					at: (self randomObject nextInt: dropColumns size)). ]
		ifTrue: [ self randomValue: 1 ].
! !

!StackAttackCrane methodsFor: 'craneMovement' stamp: 'fl 7/18/2007 19:11'!
move: aDirection

	self moveGraphic: aDirection.
	(self box)
		ifNotNil: [self box moveGraphic: self class right]! !

!StackAttackCrane methodsFor: 'craneMovement' stamp: 'fl 7/8/2007 17:14'!
prepareBox

	self box matrixPos: self randomValue@1.
	self stackAttackField fieldMatrix putInto: self box.
! !

!StackAttackCrane methodsFor: 'accessing' stamp: 'be 7/9/2007 19:25'!
box
	"^ <StackAttackBox>"

	^ box! !

!StackAttackCrane methodsFor: 'accessing' stamp: 'be 7/9/2007 19:26'!
box: aStackAttackBox

	box := aStackAttackBox! !

!StackAttackCrane methodsFor: 'accessing' stamp: 'be 7/9/2007 19:27'!
randomObject
	"^ <Random>"
	
	^ randomObject! !

!StackAttackCrane methodsFor: 'accessing' stamp: 'be 7/9/2007 19:28'!
randomObject: aRandom

	randomObject := aRandom! !

!StackAttackCrane methodsFor: 'accessing' stamp: 'be 7/9/2007 19:28'!
randomValue
	"^ <Integer>"
	
	^ randomValue! !

!StackAttackCrane methodsFor: 'accessing' stamp: 'be 7/9/2007 19:28'!
randomValue: anObject

	randomValue := anObject! !

!StackAttackCrane methodsFor: 'boxHandling' stamp: 'or 7/23/2007 10:18'!
createNewBox
	
	self box:
		((self stackAttackField objectCreator makeBoxAt: (self randomValue)@1)
			position: self startPosition + (0@StackAttackField craneHeight);
			state: #passive).! !

!StackAttackCrane methodsFor: 'boxHandling' stamp: 'be 7/21/2007 23:14'!
dropBox

	((self box checkCollision: self box class down) = #object)
		ifTrue: [
			self stackAttackField fieldMatrix
					resetAt: self box matrixPos ]
		ifFalse: [
			self box state: #fall.
			self box: nil.
			self stackAttackField increaseHighscore: #box ]
	! !

!StackAttackCrane methodsFor: 'cranePosition' stamp: 'CT 7/9/2007 16:24'!
dropPosition

	^	self stackAttackField bounds origin
			+ (self randomValue - 1
				* (StackAttackField pictureSize)@0)! !

!StackAttackCrane methodsFor: 'cranePosition' stamp: 'mja 7/23/2007 03:06'!
endPosition

	^	self stackAttackField bounds origin
			+ (self stackAttackField fieldMatrix gameColumnCount
				* (StackAttackField pictureSize)@0)! !

!StackAttackCrane methodsFor: 'cranePosition' stamp: 'CT 7/9/2007 16:26'!
startPosition

	^	self stackAttackField bounds origin
			- ((StackAttackField pictureSize)@0)! !

!StackAttackCrane methodsFor: 'initialization' stamp: 'or 7/7/2007 14:59'!
initialize
	
	super initialize.
	self
		randomObject: Random new;
		stateDictionary: self initStateDictionary;
		state: #atStartPosition.! !

!StackAttackCrane methodsFor: 'initialization' stamp: 'fl 7/18/2007 19:12'!
initStateDictionary

	^	(IdentityDictionary new
			add: #atStartPosition -> [self stepStart];
			add: #atDropPosition -> [self stepDrop];
			add: #atEndPosition -> [self stepBeam];
			add: #move -> [self stepHorizontal: self class right];
			yourself).! !

!StackAttackCrane methodsFor: 'stepping' stamp: 'CT 6/18/2007 19:27'!
step

	(self stateDictionary at: self state ifAbsent: []) value.! !

!StackAttackCrane methodsFor: 'stepping' stamp: 'be 7/5/2007 19:24'!
stepBeam

	self 
		beamLeft;
		state: #atStartPosition! !

!StackAttackCrane methodsFor: 'stepping' stamp: 'be 7/5/2007 19:31'!
stepDrop

	self 
		dropBox;
		state: #move! !

!StackAttackCrane methodsFor: 'stepping' stamp: 'fl 7/18/2007 19:11'!
stepHorizontal: aDirection

	self move: aDirection.

	(self position = self dropPosition)
		ifTrue: [ self state: #atDropPosition ].
	(self position = self endPosition)
		ifTrue: [ self state: #atEndPosition ]! !

!StackAttackCrane methodsFor: 'stepping' stamp: 'be 7/9/2007 19:25'!
stepStart

	self createARandomValue.
	(self box)
		ifNil: [ self createNewBox ]
		ifNotNil: [ self prepareBox ].
	self state: #move.! !

!StackAttackCrane methodsFor: 'stepping' stamp: 'CT 6/16/2007 15:08'!
stepTime

	^ 25! !


!StackAttackFallingMorph methodsFor: 'collisionDetection' stamp: 'fl 7/8/2007 15:25'!
checkCollision: aDirection
	"checks whether the sender collides with a wall, the ground, an object or not"	

	(self facesAWall: aDirection)
		ifTrue: [ ^ #wall ].
	(self facesTheGround: aDirection)
		ifTrue: [ ^ #ground ].
	(self facesAnObject: aDirection)
		ifTrue: [ ^ #object ].
		
	^ #space! !

!StackAttackFallingMorph methodsFor: 'collisionDetection' stamp: 'mja 7/23/2007 03:00'!
facesAnObject: aDirection
	"checks whether the sender faces an object or not"	

	^ self stackAttackField fieldMatrix isFilledAt: (self matrixPos + aDirection)! !

!StackAttackFallingMorph methodsFor: 'collisionDetection' stamp: 'mja 7/23/2007 03:00'!
facesAWall: aDirection
	"checks whether the sender faces a wall or not"	

	^ ((self matrixPos x = 1) and: [aDirection = self class left])
		or: [(self matrixPos x = self stackAttackField fieldMatrix gameColumnCount)
			and: [aDirection = self class right]]
		 ! !

!StackAttackFallingMorph methodsFor: 'collisionDetection' stamp: 'mja 7/23/2007 03:00'!
facesTheGround: aDirection
	"checks whether the sender faces the ground or not"	

	^ (self matrixPos y = self stackAttackField fieldMatrix gameRowCount) 
		and: [aDirection = self class down]
		 ! !

!StackAttackFallingMorph methodsFor: 'initialization' stamp: 'fl 7/8/2007 16:42'!
initialize

	super initialize.
	self
		currentDistance: 0;
		stateDictionary: self initStateDictionary;
		state: #idle.! !

!StackAttackFallingMorph methodsFor: 'initialization' stamp: 'mja 7/18/2007 17:58'!
initStateDictionary

	^	(IdentityDictionary new
			add: #fall -> [self stepFall];
			add: #left -> [self stepHorizontal: self class left];
			add: #right -> [self stepHorizontal: self class right];
			add: #up -> [self stepUp];
			add: #wait -> [self stepWait];
			add: #idle -> [self stepIdle];
			add: #passive -> [];
			yourself).! !

!StackAttackFallingMorph methodsFor: 'position' stamp: 'mja 7/20/2007 23:48'!
isAbove: aStackAttackPlayer

	^ aStackAttackPlayer matrixPos = (self matrixPos + self class down)! !

!StackAttackFallingMorph methodsFor: 'position' stamp: 'be 7/9/2007 18:55'!
isBetweenPositions

	^ (self currentDistance \\ StackAttackField pictureSize ~= 0)! !

!StackAttackFallingMorph methodsFor: 'movement' stamp: 'mja 7/10/2007 11:52'!
isMovable: aDirection

	self subclassResponsibility! !

!StackAttackFallingMorph methodsFor: 'movement' stamp: 'mja 7/5/2007 15:53'!
moveInMatrix: aDirection
	"moves object in matrix"

	self stackAttackField fieldMatrix 
			moveObjectFrom: self matrixPos
				to: self matrixPos + aDirection.
	self
		matrixPos: self matrixPos + aDirection.! !

!StackAttackFallingMorph methodsFor: 'accessing' stamp: 'be 7/9/2007 18:49'!
matrixPos
	"^ <Point>"
	
	^ matrixPos! !

!StackAttackFallingMorph methodsFor: 'accessing' stamp: 'be 6/11/2007 21:27'!
matrixPos: aPosition

	matrixPos := aPosition! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'CT 6/14/2007 20:53'!
step

	(self stateDictionary at: self state ifAbsent: []) value.! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'be 7/9/2007 18:52'!
stepFall
	
	
	(self currentDistance \\ StackAttackField pictureSize = 0)
		ifTrue: [
			self currentDistance: 0.
			((self checkCollision: self class down) = #space)
				ifTrue: [ 
					self 
						moveInMatrix: self class down;
						stepMoveDown. ]
				ifFalse: [
					self 
						stepTestForGameOver;
						state: #idle.
					self stackAttackField checkLastLine. ] ]
		ifFalse: [ self stepMoveDown ]! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'be 7/9/2007 18:54'!
stepHorizontal: aDirection

	((self currentDistance = 0) or: [self isBetweenPositions])
		ifTrue: [
			self 
				moveGraphic: aDirection;
				increaseCurrentDistance ]
		ifFalse: [
			self stackAttackField checkPicture.
			self 
				currentDistance: 0;
				state: #fall ]
					! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'mja 7/23/2007 02:41'!
stepIdle
	
	
	((self checkCollision: self class down) = #space)
		ifTrue: [
			self state: #fall. ]! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'or 7/7/2007 16:21'!
stepMoveDown

	self 
		moveGraphic: self class down;
		increaseCurrentDistance.! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'be 7/9/2007 19:15'!
stepTestForGameOver

	(self isAbove: self stackAttackField player1)
		ifTrue: [ self stackAttackField player1
					gameOver: #playerGameOver ].
			
	(self isAbove: self stackAttackField player2)
		ifTrue: [ self stackAttackField player2
					gameOver: #secondPlayerGameOver ].
	
	( (self stackAttackField player1 isGameOver)
		and: [self stackAttackField player2 isGameOver] )
			ifTrue: [ self stackAttackField owner gameOver ]! !

!StackAttackFallingMorph methodsFor: 'stepping' stamp: 'CT 6/14/2007 19:39'!
stepTime

	^ 25! !


!StackAttackBox methodsFor: 'movement' stamp: 'be 7/9/2007 15:04'!
isMovable: aDirection
	"answers if box can be moved by the player"

	^ ((self checkCollision: aDirection) = #space) 
		and: [(self checkCollision: self class up) = #space]
		and: [self state = #idle]! !


!StackAttackMovableMorph class methodsFor: 'directions' stamp: 'or 7/7/2007 16:11'!
left

	^ -1@0.! !

!StackAttackMovableMorph class methodsFor: 'directions' stamp: 'or 7/7/2007 16:11'!
right

	^ 1@0.! !


!StackAttackFallingMorph class methodsFor: 'directions' stamp: 'or 7/7/2007 16:10'!
down

	^ 0@1.! !

!StackAttackFallingMorph class methodsFor: 'directions' stamp: 'or 7/17/2007 11:57'!
up

	^ 0@-1.! !


!StackAttackPlayer methodsFor: 'currentGame' stamp: 'be 7/9/2007 19:36'!
canJump

	^ ((self checkCollision: self class up) = #object) not 
		and: [ ((self checkCollision: self class down) = #ground)
				or: [(self checkCollision: self class down) = #object] ]! !

!StackAttackPlayer methodsFor: 'currentGame' stamp: 'or 7/8/2007 01:01'!
gameOver: aSymbol

	self 
		changePicture: aSymbol;
		isGameOver: true.! !

!StackAttackPlayer methodsFor: 'pictureReplacement' stamp: 'be 7/9/2007 14:16'!
changePicture: aSymbol

	self image: (self stackAttackField objectCreator pictureDictionary at: aSymbol).! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'or 7/7/2007 16:22'!
getDirectionState: aDirection

	(aDirection = self class left)
		ifTrue: [^ #left]
		ifFalse: [^ #right]! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'mja 7/21/2007 14:49'!
getNeighbor: aDirection

	^ self stackAttackField fieldMatrix 
			getObjectAt: self matrixPos + aDirection! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'or 7/7/2007 15:27'!
isMovable: aDirection

	^ false! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'mja 7/23/2007 03:12'!
jump
	
	(self state = #idle)
		ifTrue: [
			(self matrixPos y = StackAttackMatrix lowestFillableGameRowIndex)
				ifFalse: [
					(self canJump)
						ifTrue: [ self state: #up. ] ] ]! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'mja 7/21/2007 14:49'!
moveBoxIfPossible: aDirection

	| box dir |
	dir := self getDirectionState: aDirection.
	box := self getNeighbor: aDirection.
	(box isMovable: aDirection)
		ifTrue: [
			box 
				moveInMatrix: aDirection;
				state: dir.
			^ true ]
		ifFalse: [ ^ false ]
	! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'mja 7/21/2007 00:38'!
move: aDirection
	"moves the player in aDirection (left or right) if possible"
	
	((self isGameOver) not and:[self state = #idle or: [self state = #wait]])		
		ifTrue: [
				((self checkCollision: aDirection) = #space) 
					ifTrue: [ self setMove: aDirection. ]
					ifFalse: [
						((self checkCollision: aDirection) = #object)
							ifTrue: [
								(self moveBoxIfPossible: aDirection)
									ifTrue: [ self setMove: aDirection ] ] ] ]! !

!StackAttackPlayer methodsFor: 'movement' stamp: 'fl 7/8/2007 16:17'!
setMove: aDirection

	self 
		moveInMatrix: aDirection;
		state: (self getDirectionState: aDirection);
		currentDistance: 0.! !

!StackAttackPlayer methodsFor: 'accessing' stamp: 'be 7/21/2007 23:23'!
isGameOver
	"^ <Boolean>"
	
	^ isGameOver! !

!StackAttackPlayer methodsFor: 'accessing' stamp: 'be 7/21/2007 23:24'!
isGameOver: aBoolean

	isGameOver := aBoolean! !

!StackAttackPlayer methodsFor: 'accessing' stamp: 'be 7/9/2007 19:33'!
pictureDictionary
	"^ <Dictionary>"
	
	^ pictureDictionary! !

!StackAttackPlayer methodsFor: 'accessing' stamp: 'be 6/11/2007 21:33'!
pictureDictionary: aDictionary

	pictureDictionary := aDictionary! !

!StackAttackPlayer methodsFor: 'stepping' stamp: 'be 7/9/2007 19:48'!
stepUp

	(self currentDistance = 0)
		ifTrue: [
			self 
				moveInMatrix: self class up;
				moveGraphic: self class up;
				increaseCurrentDistance. ]
		ifFalse: [
			(self currentDistance \\ 50 = 0)
				ifTrue: [
					self 
						currentDistance: 0;
						state: #wait. ]
				ifFalse: [
					self 
						moveGraphic: self class up;
						increaseCurrentDistance. ] ]! !

!StackAttackPlayer methodsFor: 'stepping' stamp: 'be 7/9/2007 19:48'!
stepWait

	(self currentDistance < (self standardMove * 250 / self stepTime))
		ifTrue:  [ self increaseCurrentDistance ]
		ifFalse: [ 
			self 
				currentDistance: 0;
				state: #fall. ]
		! !


!StackAttackSplash methodsFor: 'buttons' stamp: 'fl 7/9/2007 22:47'!
addColumnDecreaseButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self stackAttack createFormFrom: self class decreasePicturePath);
		position: (self position + (100@0));
		actionSelector: 'columnDecrease';
		target: self.! !

!StackAttackSplash methodsFor: 'buttons' stamp: 'fl 7/9/2007 22:47'!
addColumnIncreaseButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self stackAttack createFormFrom: self class increasePicturePath);
		position: (self position + (150@0));
		actionSelector: 'columnIncrease';
		target: self.! !

!StackAttackSplash methodsFor: 'buttons' stamp: 'fl 7/9/2007 22:47'!
addRowDecreaseButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self stackAttack createFormFrom: self class decreasePicturePath);
		position: (self position + (0@100));
		actionSelector: 'rowDecrease';
		target: self.! !

!StackAttackSplash methodsFor: 'buttons' stamp: 'fl 7/9/2007 22:47'!
addRowIncreaseButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self stackAttack createFormFrom: self class increasePicturePath);
		position: (self position + (0@150));
		actionSelector: 'rowIncrease';
		target: self.! !

!StackAttackSplash methodsFor: 'buttons' stamp: 'CT 7/9/2007 17:23'!
addStartGameButton

	| button |
	button := self initButton.
	button
		labelGraphic: (self stackAttack createFormFrom: self class startGamePicturePath);
		position: (self position + (0@0));
		actionSelector: 'startGame';
		target: self.! !

!StackAttackSplash methodsFor: 'buttons' stamp: 'CT 7/9/2007 17:11'!
initButton

	| button |
	
	button := IconicButton new.
	button
		initializeAllButLabel;
		useRoundedCorners;
		borderStyle: (BorderStyle width: 0);
		color: Color transparent.

	self addMorph: button.
	^ button! !

!StackAttackSplash methodsFor: 'resizing' stamp: 'be 7/9/2007 23:43'!
columnDecrease
	
	(self matrixSize x > StackAttack minSize x)
		ifTrue: [
			self matrixSize: self matrixSize - (1@0).
			self stackAttack resize: -1@0 ]! !

!StackAttackSplash methodsFor: 'resizing' stamp: 'CT 7/9/2007 18:07'!
columnIncrease
	
	self matrixSize: self matrixSize + (1@0).
	self stackAttack resize: 1@0.! !

!StackAttackSplash methodsFor: 'resizing' stamp: 'be 7/9/2007 23:43'!
rowDecrease
	
	(self matrixSize y > StackAttack minSize y)
		ifTrue: [
			self matrixSize: self matrixSize - (0@1).
			self stackAttack resize: 0@(-1) ]! !

!StackAttackSplash methodsFor: 'resizing' stamp: 'CT 7/9/2007 18:07'!
rowIncrease
	
	self matrixSize: self matrixSize + (0@1).
	self stackAttack resize: 0@1.! !

!StackAttackSplash methodsFor: 'initialization' stamp: 'CT 7/9/2007 17:09'!
initButtons

	self
		addStartGameButton;
		addRowDecreaseButton;
		addRowIncreaseButton;
		addColumnDecreaseButton;
		addColumnIncreaseButton.! !

!StackAttackSplash methodsFor: 'initialization' stamp: 'mr 7/10/2007 12:41'!
initialize
	
	super initialize.
	self
		borderStyle: (BorderStyle width: 0);
		color: Color transparent.! !

!StackAttackSplash methodsFor: 'initialization' stamp: 'CT 7/9/2007 17:03'!
startGame
	
	self stackAttack startGame: self matrixSize.
	self delete.! !

!StackAttackSplash methodsFor: 'accessing' stamp: 'be 7/9/2007 23:43'!
matrixSize
	"^ <Integer>"
	
	^ matrixSize! !

!StackAttackSplash methodsFor: 'accessing' stamp: 'be 7/9/2007 23:44'!
matrixSize: anInteger

	matrixSize := anInteger! !

!StackAttackSplash methodsFor: 'accessing' stamp: 'be 7/9/2007 23:44'!
stackAttack
	"^ <StackAttack>"
	
	^ stackAttack! !

!StackAttackSplash methodsFor: 'accessing' stamp: 'be 7/9/2007 23:44'!
stackAttack: aStackAttack

	stackAttack := aStackAttack! !


!StackAttackSplash class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:13'!
decreasePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/minus.png'! !

!StackAttackSplash class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:14'!
increasePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/plus.png'! !

!StackAttackSplash class methodsFor: 'picturePath' stamp: 'rkrk 1/10/2008 14:13'!
startGamePicturePath

	^ SmalltalkImage current imagePath , FileDirectory slash , 'pictures/StackAttack/startGame.png'! !

